﻿using System;
using System.Windows.Forms;
using System.Xml.Serialization;
using SpringCombos.Properties;

namespace SpringCombos
{
    [Serializable, XmlRoot(ElementName = "KeyboardCombo")]
    public class KeyboardCombo : Combo
    {
#region Public Enums, Properties and Fields

        [XmlElement(ElementName = "Key")]
        public Keys Keys { get; set; }

        [XmlElement(ElementName = "ComboAction")]
        public ComboAction ComboAction { get; set; }

#endregion

#region Constructors, Destructors and Finalizers

        [UsedImplicitly]
        public KeyboardCombo()
        {
        }

        public KeyboardCombo(KeyEventArgs args, ComboAction comboAction) : this(args.KeyData) =>
            ComboAction = comboAction;

        private KeyboardCombo(Keys args) => Keys = args;

#endregion
    }
}
