﻿using System;
using System.Xml.Serialization;
using SpringCombos.Properties;

namespace SpringCombos
{
    [Serializable, XmlRoot(ElementName = "PauseCombo")]
    public class PauseCombo : Combo
    {
#region Public Enums, Properties and Fields

        [XmlElement(ElementName = "Time")]
        public string Time
        {
            get => TimeSpan.ToString();
            set
            {
                if (TimeSpan.TryParse(value, out var timeSpan))
                {
                    TimeSpan = timeSpan;
                }
            }
        }

        [XmlElement(ElementName = "Fuzz")]
        public int Fuzz
        {
            get => _fuzz;
            set => _fuzz = value;
        }

        [XmlIgnore] public TimeSpan TimeSpan;

#endregion

#region Private Delegates, Events, Enums, Properties, Indexers and Fields

        private int _fuzz;

#endregion

#region Constructors, Destructors and Finalizers

        [UsedImplicitly]
        public PauseCombo()
        {
        }

        public PauseCombo(TimeSpan timeSpan) => TimeSpan = timeSpan;

#endregion
    }
}
